// very basic unit testing of the RNAstructure library

#ifndef UNIT_TESTS_H
#define UNIT_TESTS_H

#include <vector>
#include <string>
#include <iostream>
#include <cstdio>
#include "../RNA_class/RNA.h"

#define TEST_EQUAL(ACTUAL,EXPECTED)  test_equal(ACTUAL, EXPECTED, __LINE__)

void post_result(bool passed);

template<class T>
void test_equal(T actual, T expected, int line) {
	bool pass = actual == expected;
	post_result(pass);
	if (pass)
		std::cout << "PASSED TEST[" << line << "] Expected==Actual==\"" << actual << "\"" << std::endl; 
	else
		std::cerr << "!! FAILED TEST[" << line << "] Expected: \"" << expected << "\" Actual: \"" << actual << "\"" << std::endl; 
}

void test_equal(const char* const actual, const char* const expected, int line) {
	return test_equal((std::string)actual, (std::string)expected, line);
}
void test_equal(std::string actual, std::string expected, int line) {
	bool pass = actual == expected;
	post_result(pass);
	escapeChars(actual); escapeChars(expected);
	if (actual.size() > 90) { actual.resize(89); actual.append("…"); }
	if (expected.size() > 90) { expected.resize(89); expected.append("…"); }
	if (pass) 
		std::cout << "PASSED TEST[" << line << "] Expected==Actual==\"" << actual << "\"" << std::endl; 
	else
		std::cerr << "!! FAILED TEST[" << line << "] Expected: \"" << expected << "\" Actual: \"" << actual << "\"" << std::endl; 
}

#endif //UNIT_TESTS_H